
import maxtemplatefitter as tf

from rdstar.utilities.logging import set_logger, reset_third_party_logging_level

from rdstar.offline_analysis.dstst_analysis.utility import prepare_weights
from rdstar.offline_analysis.dstst_analysis.utility import load_dataframes, combine_dataframe_dict, prepare_mct


logger = set_logger(name="rdstar_dss_max_fit", overwrite=True)
reset_third_party_logging_level()

result_dir = "/storage/9/welsch/DststFit/AsimovResults"
plot_tag = "asimov"

df_dict = load_dataframes()
total_mc = combine_dataframe_dict(df_dict)
total_mc = prepare_weights(total_mc)
mct, hists, templates = prepare_mct(total_mc, weight="weight")
mct.add_data(**mct.generate_asimov_dataset())
mct.reset_parameters()
fitter = tf.TemplateFitter(mct, "iminuit")
print(fitter.get_significance("DSSl"))
# import pdb; pdb.set_trace()
# pp, pv, hesse = fitter.profile("DSSl_yield", num_cpu=10, fix_nui_params=True)

# plt.plot(pp, pv)
