import os
import pandas as pd

from rdstar.offline_analysis.fitting.dedicated_fit_approach.dss_cal_evaluation.dss_cal_eval_tools import (
    DssCalEvalResult,
)

__all__ = [
    "apply_dss_calibration",
]


_dss_cal_fit_scenario_name: str = "dss_c_third_approach"

_dss_cal_selection_name: str = "main_selection_with_right_sig_tag_comb"
_dss_cal_fit_obs_setup_tag: str = "DssCalObsSetup3_mms_mdiffdds"

base_dss_cal_res_dir_path: str = "/home/fmetzner/Downloads/"
dss_cal_eval_name: str = "DssCalEvaluation_05thJune2023"


def apply_dss_calibration(df: pd.DataFrame) -> pd.DataFrame:
    _dss_cal_file_name: str = (
        f"{_dss_cal_fit_scenario_name}__{_dss_cal_selection_name}__{_dss_cal_fit_obs_setup_tag}.json"
    )
    _dss_cal_file_path = os.path.join(base_dss_cal_res_dir_path, dss_cal_eval_name, _dss_cal_file_name)
    assert os.path.isfile(_dss_cal_file_path), _dss_cal_file_path

    dss_cal_corr_result = DssCalEvalResult.load_from_file(file_path=_dss_cal_file_path)
    return dss_cal_corr_result.get_mc_sample_with_correction(
        df=df,
    )
